# grepreg.pl
# this script is used to search for a key or value name
# within the registry

require "NT.ph";

sub printmatch {
    my $rootkey = shift @_;
    my $subkey = shift @_;
    my $string = shift @_;
    my $index = 0;
    my $handle = "";
     
    Win32::RegOpenKeyEx($rootkey, $subkey, &NULL, &KEY_ALL_ACCESS, $handle) 
        or die "unable to open key $subkey";
    while(Win32::RegEnumKeyEx($handle, $index++, $keyname, &NULL, $class, $time)) {
        if($keyname =~ /.*$string.*/) {
            print "$subkey\\$keyname\n";
        }
        if($subkey eq "") {
        } else {
            $keyname = "\\$keyname";
        }
        &printmatch($rootkey, "$subkey$keyname", $string);
        
    }
    $index = 0;
    while(Win32::RegEnumValue($handle, $index++, $valuename, &NULL, $type, $value)) {
        if($valuename =~ /.*$string.*/) {
            print "whoopie";
            print "$subkey\n";
        }
    }       
    Win32::RegCloseKey($handle);
}

$rootname = $ARGV[0];
$subkey = $ARGV[1];
$string = $ARGV[2];

if ($rootname eq 'HKEY_USERS') {
    $rootkey = &HKEY_USERS;
} elsif ($rootname eq 'HKEY_LOCAL_MACHINE') {
    $rootkey = &HKEY_LOCAL_MACHINE;
}

&printmatch($rootkey, $subkey, $string);